Ideas for a Next Generation of the Stream Control Transmission Protocol (SCTP)
Internet-Draft draft-dreibholz-tsvwg-sctp-nextgen-ideas-15
Thomas Dreibholz
Simula Metropolitan Centre for Digital Engineering
Pilestredet 52
0167 Oslo
Norway
dreibh@simula.no
https://www.simula.no/people/dreibh
17 September 2022
Internet-Draft
This document collects some ideas for a next generation of the Stream Control Transmission Protocol (SCTP) for further discussion. It is a result of lessons learned from more than one decade of SCTP deployment.
Introduction
Abbreviations
- SCTP: Stream Control Transmission Protocol
Stream Control Transmission Protocol
The Stream Control Transmission Protocol (SCTP) has been defined as RFCs in [RFC3237], [RFC3436], [RFC3554], [RFC3758], [RFC4820], [RFC4895], [RFC4960], [RFC5061], [RFC6083], [RFC6096], [RFC6458], [RFC6525], [RFC6951], [RFC7053]. There is also a detailed introduction provided by [Dre2012] as well as lots of further information material on [SCTP-Website]. SCTP is therefore not introduced in more detail here.
Scope
The scope of this document is to collect some ideas of what to update/change for a next generation of the SCTP protocol. It is a result of lessons learned from more than one decade of SCTP deployment (see also [Dre2012]) as well as ongoing discussions on applying SCTP for WebRTC Data Channels (as introduced in more detail in [I-D.ietf-rtcweb-data-channel]).
What to Change in the Next Generation of SCTP?
- Make useful extensions part of the next generation core protocol itself (that is, make their implementation a MUST):
  - Partial Reliablility ([RFC3758])
  - Chunk Authentication ([RFC4895])
  - Partial Reliablility ([RFC5061])
  - Stream Reconfiguration ([RFC6525])
  - SACK Immediately ([RFC7053])
- Consider additional features as part of the next generation core protocol:
  - Non-Renegable Selective Acknowledgments (NR-SACK) ([NEY08])
  - Concurrent Multi-Path Transfer for SCTP (CMT-SCTP) ([I-D.tuexen-tsvwg-sctp-multipath])
- Chunk Authentication provides integrity but not confidentiality. There could be a feature for encryption as well, for example like [I-D.hohendorf-secure-sctp]. Having encryption directly included inside the core transport protocol may make it easier to use (less error-prone work for application developers).
- SCTP assigns a fixed TSN per DATA chunk. The TSN cannot be changed any more. That is, it is not possible for a middlebox to split chunks into smaller pieces (for example, for hardware offloading). For further discussion: may it be useful to consider a different behavior?
- Definition of path: For SCTP, a path is defined by a remote destination address. [Globecom2013], [NNUW1-Adhari-CC] shows that CMT-SCTP performance also depends on the local endpoint's outgoing links. Considering each pair of local outgoing and remote incoming address as different path may lead to improved performance in many Internet scenarios.
Security Considerations
Security considerations for SCTP can be found in [RFC5355].
IANA Considerations
This document introduces no additional considerations for IANA.
Experimental Implementations
An Open Source simulation model for SCTP is available for OMNeT++ within the INET Framework. See [INET] for the Git repository. For documentation on the model, see [Rue2009] and [Dre2012]. This model can be used to evaluate future ideas for SCTP.
Testbed Platform
NorNet is a large-scale and realistic Internet testbed platform with support for multi-homing. A description of and introduction to NorNet is provided in [ComNets2013-Core], [PAMS2013-NorNet], [NNUW1-Dreibholz-NorNetCore-Introduction], [NNUW1-Dreibholz-NorNetCore-Tutorial]. Further information can be found on the project website [NorNet-Website] at https://www.nntb.no.
Acknowledgments
The author would like to thank Martin Becke for discussions and support.
References
Normative References
[RFC3237]

Requirements for Reliable Server Pooling
M. Tuexen
Q. Xie
R. Stewart
M. Shore
L. Ong
J. Loughney
M. Stillman
January 2002
RFC 3237
DOI 10.17487/RFC3237
[RFC3436]

Transport Layer Security over Stream Control Transmission Protocol
A. Jungmaier
E. Rescorla
M. Tuexen
December 2002
RFC 3436
DOI 10.17487/RFC3436
[RFC3554]

On the Use of Stream Control Transmission Protocol (SCTP) with IPsec
S. Bellovin
J. Ioannidis
A. Keromytis
R. Stewart
July 2003
RFC 3554
DOI 10.17487/RFC3554
[RFC3758]

Stream Control Transmission Protocol (SCTP) Partial Reliability Extension
R. Stewart
M. Ramalho
Q. Xie
M. Tuexen
P. Conrad
May 2004
RFC 3758
DOI 10.17487/RFC3758
[RFC4820]

Padding Chunk and Parameter for the Stream Control Transmission Protocol (SCTP)
M. Tuexen
R. Stewart
P. Lei
March 2007
RFC 4820
DOI 10.17487/RFC4820
[RFC4895]

Authenticated Chunks for the Stream Control Transmission Protocol (SCTP)
M. Tuexen
R. Stewart
P. Lei
E. Rescorla
August 2007
RFC 4895
DOI 10.17487/RFC4895
[RFC4960]

Stream Control Transmission Protocol
R. Stewart, Ed.
September 2007
RFC 4960
DOI 10.17487/RFC4960
[RFC5061]

Stream Control Transmission Protocol (SCTP) Dynamic Address Reconfiguration
R. Stewart
Q. Xie
M. Tuexen
S. Maruyama
M. Kozuka
September 2007
RFC 5061
DOI 10.17487/RFC5061
[RFC5355]

Threats Introduced by Reliable Server Pooling (RSerPool) and Requirements for Security in Response to Threats
M. Stillman, Ed.
R. Gopal
E. Guttman
S. Sengodan
M. Holdrege
September 2008
RFC 5355
DOI 10.17487/RFC5355
[RFC6083]

Datagram Transport Layer Security (DTLS) for Stream Control Transmission Protocol (SCTP)
M. Tuexen
R. Seggelmann
E. Rescorla
January 2011
RFC 6083
DOI 10.17487/RFC6083
[RFC6096]

Stream Control Transmission Protocol (SCTP) Chunk Flags Registration
M. Tuexen
R. Stewart
January 2011
RFC 6096
DOI 10.17487/RFC6096
[RFC6458]

Sockets API Extensions for the Stream Control Transmission Protocol (SCTP)
R. Stewart
M. Tuexen
K. Poon
P. Lei
V. Yasevich
December 2011
RFC 6458
DOI 10.17487/RFC6458
[RFC6525]

Stream Control Transmission Protocol (SCTP) Stream Reconfiguration
R. Stewart
M. Tuexen
P. Lei
February 2012
RFC 6525
DOI 10.17487/RFC6525
[RFC6951]

UDP Encapsulation of Stream Control Transmission Protocol (SCTP) Packets for End-Host to End-Host Communication
M. Tuexen
R. Stewart
May 2013
RFC 6951
DOI 10.17487/RFC6951
[RFC7053]

SACK-IMMEDIATELY Extension for the Stream Control Transmission Protocol
M. Tuexen
I. Ruengeler
R. Stewart
November 2013
RFC 7053
DOI 10.17487/RFC7053
[I-D.tuexen-tsvwg-sctp-multipath]

Load Sharing for the Stream Control Transmission Protocol (SCTP)
Paul D. Amer
University of Delaware
Martin Becke
HAW Hamburg
Thomas Dreibholz
SimulaMet
Nasif Ekiz
University of Delaware
Janardhan Iyengar
Franklin and Marshall College
Preethi Natarajan
Cisco Systems
Randall R. Stewart
Netflix
Michael Tuexen
Muenster Univ. of Appl. Sciences
9 February 2022
Internet-Draft draft-tuexen-tsvwg-sctp-multipath-23
[I-D.hohendorf-secure-sctp]

Secure SCTP
Carsten Hohendorf
University of Duisburg-Essen
Esbold Unurkhaan
Mongolian University
Thomas Dreibholz
SimulaMet
6 September 2021
Internet-Draft draft-hohendorf-secure-sctp-32
[I-D.ietf-rtcweb-data-channel]

WebRTC Data Channels
Randell Jesup
Salvatore Loreto
Michael Tuexen
4 January 2015
Internet-Draft draft-ietf-rtcweb-data-channel-13
Informative References
[SCTP-Website]

Thomas Dreibholz's SCTP Page
ThomasDreibholz
2022
[Globecom2013]

Comparison of Multipath TCP and CMT-SCTP based on Intercontinental Measurements
MartinBecke
HakimAdhari
Erwin PaulRathgeb
FaFu
XiongYang
XingZhou
10 December 2013
Proceedings of the IEEE Global Communications Conference(GLOBECOM)
[NNUW1-Adhari-CC]

Practical Experiences with an Inter-Continental Testbed for Multi-Path Transport
HakimAdhari
18 September 2013
Proceedings of the 1st International NorNet Users Workshop(NNUW-1)
[Dre2012]

Evaluation and Optimisation of Multi-Path Transport using the Stream Control Transmission Protocol
ThomasDreibholz
13 March 2012
Habilitation Treatise
[INET]

INET Framework for OMNeT++
AndrásVarga
2014
[NEY08]

Non-Renegable Selective Acknowledgments (NR-SACKs) for SCTP
PreethiNatarajan
NasifEkiz
ErtuğrulYilmaz
PaulD.Amer
JanardhanR.Iyengar
October 2008
Proceedings of the 16th IEEE International Conference on Network Protocols(ICNP) Pages 187-196, ISBN978-1-4244-2506-8, DOI10.1109/ICNP.2008.4697037
[Rue2009]

SCTP – Evaluating, Improving and Extending the Protocol for Broader Deployment
IreneRüngeler
December 2009
[ComNets2013-Core]

NorNet Core – A Multi-Homed Research Testbed
Ernst GunnarGran
ThomasDreibholz
AmundKvalbein
14 March 2014
Computer Networks, Special Issue on Future Internet Testbeds Volume 61, Pages 75-87, ISSN1389-1286, DOI10.1016/j.bjp.2013.12.035
[PAMS2013-NorNet]

Design and Implementation of the NorNet Core Research Testbed for Multi-Homed Systems
ThomasDreibholz
Ernst GunnarGran
27 March 2013
Proceedings of the 3nd International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) Pages 1094-1100, ISBN978-0-7695-4952-1, DOI10.1109/WAINA.2013.71
[NNUW1-Dreibholz-NorNetCore-Introduction]

The NorNet Core Testbed – Introduction and Status
ThomasDreibholz
18 September 2013
Proceedings of the 1st International NorNet Users Workshop(NNUW-1)
[NNUW1-Dreibholz-NorNetCore-Tutorial]

The NorNet Core Testbed – An Experiment Tutorial
ThomasDreibholz
19 September 2013
Proceedings of the 1st International NorNet Users Workshop(NNUW-1)
[NorNet-Website]

NorNet – A Real-World, Large-Scale Multi-Homing Testbed
Thomas Dreibholz
2022